#include <stdlib.h>
#include <stdio.h>

int main()
{
    int nd,np,j=0,k=0;
    long long i=0,s=0,p=0;
    scanf("%d%d",&nd,&np);
    long long a[nd],b[nd],pi[np],rs[np],z=0;
    while(i<nd){
        scanf("%lld%lld",&a[i],&b[i]);
        i++;
    }
    i=0;
    while(i<np){
        scanf("%lld",&pi[i]);
        i++;
    }
    i=0;
    while(i<nd){
        z=z+b[i];
        i++;
    }
    
    i=0;
    while(i<a[nd-1]+1+s && i<pi[np-1]+1+s && i<z){
        if(a[k]==i){
            s=s+b[k];
            k++;
        }
        if(s>0){
            p++;
            s--;
            
        }
        if(pi[j]<=i){
            
            pi[j]=p;
            j++;
        }
        i++;
        
    }
    i=0;
    while(i<np){
        printf("%lld\n",pi[i]);
        i++;
    }
    
    return 0;
}